lab8/myimgor/images/urls.py
from django.urls import path
from .views import image_list
from .views import image_detail
from .views import create_image
from .views import create_comment

app_name = "images"
urlpatterns = [
    path('', image_list, name="list"),
    path('<int:image_id>/', image_detail, name='detail'),
    path('new/', create_image, name="create"),
    path('<int:image_id>/comments/new/', create_comment, name="create_comment")
]

lab8/myimgor/myimgor/urls.py
from django.contrib import admin
from django.urls import path, include

from images.views import homepage

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', homepage, name='homepage'),
    path('images/', include('images.urls')),
    path('accounts/', include('django.contrib.auth.urls')),

]

lab8/myimgor/images/models.py
from django.db import models
from django.utils import timezone

# Create your models here.
class Image(models.Model):
    title = models.CharField(max_length=100)
    desc = models.CharField(max_length=512, blank=True)
    pub_date = models.DateTimeField()
    url = models.CharField(max_length=512)

    def __str__(self):
        return self.title

class Comment(models.Model):
    image = models.ForeignKey(Image, on_delete=models.CASCADE)
    author = models.CharField(max_length=128)
    content = models.CharField(max_length=512)
    created_at = models.DateTimeField(auto_now_add=True)

    def __str__(self):
        return f"{self.author}: {self.content[:30]}"

lab8/myimgor/images/views.py
from django.shortcuts import render, get_object_or_404
from django.http import HttpResponse, HttpRequest, HttpResponseRedirect
from .models import Image
from django.utils import timezone
from django.urls import reverse

# Create your views here.
def homepage(request):
    count = Image.objects.count()
    context = {
        "count": count,
    }
    return render(request,'images/homepage.html', context)

def image_list(request):
    images = Image.objects.all()
    context = {
        "images": images,
    }
    return render(request, 
                'images/image_list.html', 
                context)

def image_detail(request, image_id):
    image = Image.objects.get(id=image_id)
    comments = image.comment_set.all()
    context = {
        "image": image,
        "comments": comments,
    }
    return render(request,
                  'images/image_detail.html',
                  context
                )

def create_image(request: HttpRequest):
    if request.method == "POST":
        title = request.POST.get('title', "")
        url = request.POST.get("url", "")
        pub_date = request.POST.get("pub_date", 
                           timezone.now())
        desc = request.POST.get("desc", "")
        image = Image(title=title,
                      desc=desc,
                      pub_date=pub_date,
                      url=url)
        image.save()
        return HttpResponseRedirect(
            reverse('images:detail', args=(image.id,))
        )
        

    context = {}
    return render(request,
                 "images/create_image.html",
                 context)
            
def create_comment(request, image_id):
    if request.method == "POST":
        image = get_object_or_404(Image, pk=image_id)
        author = request.POST.get("author", "Anonymous")
        content = request.POST.get("content", "")
        image.comment_set.create(
            author=author,
            content=content
        )

    return HttpResponseRedirect(
        reverse('images:detail', 
        args=(image.id,))
    )

lab8/myimgor/images/templates/images/base.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
</head>
<body>
    <div>
        <a href="/">Home</a>
        <a href="{% url 'images:list' %}">Slike</a>
        <a href="{% url 'images:create' %}">Dodaj sliku</a>
        {% if request.user.is_authenticated %}
        {{ request.user.username }} 
        <a href="{% url 'logout' %}">Odjava</a>
        {% else %}
        <a href="#">Prijavi se</a>
        {% endif %}

        {% if request.user.is_superuser %}
        <a href="/admin">Admin dashboard</a>
        {% endif %}
    </div>
    <h1>Myimgur</h1>

    {% block content %}
    <p>Ovo je defaultni text</p>
    {% endblock content %}
</body>
</html>

lab8/myimgor/images/templates/images/create_image.html
{% extends 'images/base.html' %}

{% block content %}
<div>
    <h1>Dodaj novu sliku</h1>
    <form action="" method="POST">
        {% csrf_token %}
        <label for="title">Title</label>
        <input type="text" name="title" id="title"> <br>
        <label for="url">url</label>
        <input type="text" name="url" id="url"> <br>
        <label for="desc">desc</label>
        <input type="text" name="desc" id="desc"> <br>
        <label for="pub_date">Pub_date</label>
        <input type="date" name="pub_date" id="pub_date"> <br>
        <input type="submit" value="Submit images">
    </form>
</div>
{% endblock content %}

lab8/myimgor/images/templates/images/homepage.html
{% extends 'images/base.html' %}

{% block content %}
    <p>Pogledaj našu bazu od {{ count }} slika</p>
    <p>
        <a href="{% url 'images:list' %}">Vidi slike!</a>
    </p>

{% endblock content %}

lab8/myimgor/images/templates/images/image_detail.html
{% extends 'images/base.html' %}

{% block content %}
    <h1>{{ image.title }}</h1>
    <div>
        <div>
            <img src="{{ image.url }}" style="width: 150px;">
            <p>{{ image.desc }}</p>
        </div>
    </div>
    <div>
        <h1>Dodaj komentar</h1>
        <form action="{% url 'images:create_comment' image.id %}" method="POST">
            {% csrf_token %}
            <label for="">Autor</label> <br>
            <input type="text" name="author"> <br>
            <label for="">Comment</label><br>
            <textarea name="content" id="" cols="30" rows="4"></textarea><br>
            <input type="submit" value="Pošalji komentar">
        </form>
        <h1>Komentari</h1>
        {% for comment in comments %}
        <div>
            <p><strong>{{ comment.author }}</strong></p>
            <p>{{ comment.content }}</p>
            <p><small>{{ comment.created_at }}</small></p>
        </div>
        <hr>
        {% endfor %}
    </div>
{% endblock content %}
    

lab8/myimgor/images/templates/images/image_list.html
{% extends 'images/base.html' %}

{% block content %}
    <h1>Slike</h1>
    <div>
        {% for image in images %}
            <div>
                <a href="{% url 'images:detail' image.id %}">
                    <p>{{ image.title }}</p>
                </a>
                <img src="{{ image.url }}" style="width: 150px;">
                <p>{{ image.desc }}</p>
            </div>
        {% endfor %}    
    </div>
{% endblock content %}
    